import 'dart:async';
import 'dart:collection';

import 'package:flutter/services.dart';

class FlutterMob {
  static const MethodChannel _channel = const MethodChannel('flutter_mob');

  static Future<void> init(String appKey, String appSecret) async {
    await _channel.invokeMethod('init', {'appKey': appKey, 'appSecret': appSecret});
  }

  static Future<void> config([HashMap<String, Object> wechat, HashMap<String, Object> wechatMoments, HashMap<String, Object> qq, HashMap<String, Object> sina]) async {
    await _channel.invokeMethod('config', {'wechat': wechat, 'wechatMoments': wechatMoments, 'qq': qq, 'sina': sina});
  }

  static Future<Result> qqLogin() async {
    final Map<dynamic, dynamic> login = await _channel.invokeMethod('qqLogin');
    Result result = new Result();
    result.status = login["status"];
    result.msg = login["msg"];
    return result;
  }

  static Future<Result> wechatLogin() async {
    final Map<dynamic, dynamic> login = await _channel.invokeMethod('wechatLogin');
    Result result = new Result();
    result.status = login["status"];
    result.msg = login["msg"];
    return result;
  }

  static Future<Result> sinaLogin() async {
    final Map<dynamic, dynamic> login = await _channel.invokeMethod('sinaLogin');
    Result result = new Result();
    result.status = login["status"];
    result.msg = login["msg"];
    return result;
  }

  static Future<void> share() async {
    await _channel.invokeMethod('share');
  }
}

class Result {
  int status;
  String msg;
}